package ch.cern.lhcb.xmleditor;

import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * Class for accessing default ResourceBundle
 */
public class ResourceManager {

    private static final String BUNDLE_NAME = "ch.cern.lhcb.xmleditor.Resources";

    private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
            .getBundle(BUNDLE_NAME);

    private ResourceManager() {
    }

    /**
     * Returns resource based on the key
     * @param key key for the resource
     * @return resource string
     */
    public static String getString(String key) {
        try {
            return RESOURCE_BUNDLE.getString(key);
        } catch (MissingResourceException e) {
            return '!' + key + '!';
        }
    }
}