<?xml version="1.0"?>
<xsl:stylesheet  version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:math="http://www.w3.org/1998/Math/MathML" >

	<xsl:strip-space elements="*"/>
	<!--differentiation for exponential equations. Expects differential to be defined thru with-param with the bvar. Calls the
	diffterms template assuming a polynomial power of the bvar as a part of the chain rule.  For example, <math>
		<apply>
	  <exp/>
	  <apply>
	    <divide/>
	      <apply>
		<times/>
	    <cn>-1</cn>
	      <apply>
		<power/>
		<ci>x</ci>
		<cn>-2</cn>
	      </apply>
	      </apply>
	    <ci>&sigma;</ci>
	  </apply>
	</apply>=	<apply>
          <times/>
     <apply>
	  <exp/>
	  <apply>
	    <divide/>
	      <apply>
		<times/>
	    <cn>-1</cn>
	      <apply>
		<power/>
		<ci>x</ci>
		<cn>-2</cn>
	      </apply>
	      </apply>
	    <ci>&sigma;</ci>
	  </apply>
	</apply>
    <apply>
      <diff/>
      <bvar><ci>x</ci></bvar>
	  <apply>
	    <divide/>
	      <apply>
		<times/>
	    <cn>-1</cn>
	      <apply>
		<power/>
		<ci>x</ci>
		<cn>-2</cn>
	      </apply>
	      </apply>
	    <ci>&sigma;</ci>
	  </apply>
	</apply>
	</apply>
</math>
 This assumption needs to be
	confirmed in future development. -->
	<xsl:template  name="diffexp" match="math:apply/math:exp">
	<xsl:param name="differential" select="string('x')"/>
	<xsl:apply-templates select="../*[3]"/><xsl:text>*</xsl:text>
	<xsl:for-each select="../*[3]/*[3]/*[2]">
				<xsl:call-template name="diffterms">
				<xsl:with-param name="differential" select="$differential"/>
				</xsl:call-template>
	</xsl:for-each>
	</xsl:template>
	<!--pluses and minuses are used to delimit derivatives of terms.  For each term the correct derivative rules are
	determined and the implementing template called.
	-->
	<xsl:template  name="diffterms">
	<xsl:param name="differential" select="string('x')"/>
	<!--Look for special cases and produce the source code of the derivative-->
	<xsl:choose>
	<xsl:when test="*[name()='divide'] and *[2]/*[position()=1 and name()='times'] and *[2]/*[position()=2 and name()='cn'] and *[2]/*[3]/*[position()=1 and name()='power'] and *[2]/*[3]/*[position()=2 and name()='ci']  and string(*[2]/*[3]/*[2])=$differential and *[2]/*[3]/*[position()=3 and name()='cn']">
	<xsl:variable name="constant" select="*[2]/*[2]"/>
	<xsl:variable name="power" select="*[2]/*[3]/*[3]"/>
	<xsl:text>(</xsl:text><xsl:value-of select="$constant*$power"/>)<xsl:text>/(</xsl:text><xsl:apply-templates select="./*[3]"/><xsl:text>))</xsl:text>
	</xsl:when>
	<xsl:when test="*[name()='divide'] and *[2]/*[position()=1 and name()='times'] and *[2]/*[position()=2 and name()='cn'] and string(*[3])=$differential">
	<xsl:variable name="constant" select="*[2]/*[2]"/>
	<xsl:variable name="power" select="-1"/>
	<xsl:text>(</xsl:text><xsl:value-of select="$constant*$power"/>*<xsl:apply-templates select="./*[2]"/><xsl:text>*(</xsl:text>Math.pow(<xsl:value-of select="$differential"/>,<xsl:value-of select="$power - 1.0"/><xsl:text>)))</xsl:text>
	</xsl:when>
	<xsl:when test="*[name()='times'] and *[3]/*[position()=1 and name()='power'] and *[3]/*[2]/*[position()=1 and name()='divide'] and *[3]/*[2]/*[2]/*[position()=1 and name()='minus'] and *[3]/*[2]/*[2]/*[position()=3 and name()='ci'] and string(*[3]/*[2]/*[2]/*[3])=$differential">
	<xsl:variable name="constant" select="*[2]"/>
	<xsl:variable name="power" select="*[3]/*[3]"/>
	<xsl:text>(</xsl:text><xsl:value-of select="$constant*$power"/>*Math.pow(<xsl:apply-templates select="*[3]/*[2]"/>,<xsl:value-of select="$power - 1.0"/>)<xsl:text>*(</xsl:text>
	<xsl:for-each select="*[3]/*[2]">
	<xsl:call-template name="diffterms" >
		<xsl:with-param name="differential" select="$differential"/>
	</xsl:call-template>
	</xsl:for-each>
	<xsl:text>))</xsl:text>
	</xsl:when>
	<xsl:when test="*[name()='times'] and *[3]/*[position()=1 and name()='power'] and *[3]/*[2]/*[position()=1 and name()='divide'] and *[3]/*[2]/*[2]/*[position()=1 and name()='minus'] and *[3]/*[2]/*[2]/*[position()=3 and name()='ci'] and string(*[3]/*[2]/*[3])=$differential">
	<xsl:variable name="constant" select="*[2]"/>
	<xsl:variable name="power" select="*[3]/*[3]"/>
	<xsl:text>(</xsl:text><xsl:value-of select="$constant*$power"/>*Math.pow(<xsl:apply-templates select="*[3]/*[2]"/>,<xsl:value-of select="$power - 1.0"/>)<xsl:text>*(</xsl:text>
	<xsl:for-each select="*[3]/*[2]">
	<xsl:call-template name="diffterms" >
		<xsl:with-param name="differential" select="$differential"/>
	</xsl:call-template>
	</xsl:for-each>
	<xsl:text>))</xsl:text>
	</xsl:when>
	<xsl:when test="*[name()='divide'] and *[2]/*[name()='minus'] and *[2]/*[position()=2 and name()='ci'] and *[2]/*[position()=3 and name()='ci'] and string(*[2]/*[3])=$differential">
	<xsl:text>-1.0/</xsl:text><xsl:value-of select="*[3]"/>
	</xsl:when>
	<xsl:when test="*[name()='divide'] and *[2]/*[name()='minus'] and *[2]/*[position()=2 and name()='ci'] and *[2]/*[position()=3 and name()='ci'] and string(*[3])=$differential">
	<xsl:text>-1.0*</xsl:text><xsl:apply-templates select="*[2]"/><xsl:text>*Math.pow(</xsl:text><xsl:value-of select="*[3]"/><xsl:text>,-2.0)</xsl:text>
	</xsl:when>
	<xsl:when test="*[name()='minus'] and *[position()=2 and name()='ci'] and *[position()=3 and name()='ci'] and string(*[3])=$differential">
	<xsl:text>-1.0</xsl:text>
	</xsl:when>
	<xsl:otherwise>
	<xsl:text>0.0</xsl:text>
	</xsl:otherwise>
	</xsl:choose>
	<!--xsl:text>/*</xsl:text><xsl:value-of select="$differential"/>=<xsl:value-of select="*[2]/*[3]/*[2]"/><xsl:text>*/</xsl:text-->
	</xsl:template>
	<!--Starting pattern for the taking of deriviatives.  The style and rules of differentiation need to be chosen for
	the given function.  Need a way to find a function definition located in another part of the mathml document and it's derivative
	taken and output to the Java source at this position.  Also need to find the number of occurances in a term or branch of mathml-->
	<xsl:template match="math:diff" name="diff">
		<xsl:param name="differential" select="translate(../child::math:bvar, ' ','')"/>
		<xsl:variable name="functiontype" select="local-name(../*[3]/*[3]/*[1])"/>
		<xsl:choose>
			<!--The case where it is a derivative of a function defined elsewhere in the mathml document.-->
			<xsl:when test="local-name(../*[3]/*[1])='csymbol'">
			<xsl:variable name="functionDescription" select="translate(concat(../*[3]/*[1], ../*[3]/*[2]),' &#9;&#10;&#13;','')"/>

			<!--Get the function document location from the functions key table-->
				<xsl:for-each select="key('functions', $functionDescription)">
					<xsl:choose>
					<xsl:when test="local-name(../../*[1])='eq'">
						<xsl:for-each select="../../*[3]">
					<xsl:call-template name="diff">
						<xsl:with-param name="differential" select="$differential"/>
					</xsl:call-template>
						</xsl:for-each>
					</xsl:when>
					</xsl:choose>
				</xsl:for-each>
			</xsl:when>
			<!--Got an exponential function. Call diffexp...-->
			<xsl:when test="$functiontype='exp'">
				<xsl:call-template name="diffexp">
				<xsl:with-param name="differential" select="$differential"/>
				</xsl:call-template>
			</xsl:when>
			<!--Test for ax+b type of functions where a and b can be any mathml expression not including the bvar-->
			<xsl:when test="(local-name(../*[3]/*[1])='plus' or local-name(../*[3]/*[1])='minus') and local-name(../*[3]/*[2]/*[1])='times' and ../*[3]/*[2]/*[3]=$differential">
				<xsl:apply-templates select="../*[3]/*[2]/*[2]"/>
			</xsl:when>
			<xsl:when test="(local-name(../*[3]/*[1])='plus' or local-name(../*[3]/*[1])='minus')  and local-name(../*[3]/*[2]/*[1])='times' and ../*[3]/*[2]/*[2]=$differential">
				<xsl:apply-templates select="../*[3]/*[2]/*[3]"/>
			</xsl:when>
			<xsl:when test="(local-name(../*[3]/*[1])='plus' or local-name(../*[3]/*[1])='minus') and local-name(../*[3]/*[3]/*[1])='times' and ../*[3]/*[3]/*[3]=$differential">
				<xsl:if test="local-name(../*[3]/*[1])='minus'">-</xsl:if><xsl:apply-templates select="../*[3]/*[3]/*[2]"/>
			</xsl:when>
			<xsl:when test="(local-name(../*[3]/*[1])='plus' or local-name(../*[3]/*[1])='minus') and local-name(../*[3]/*[3]/*[1])='times' and ../*[3]/*[3]/*[2]=$differential">
				<xsl:if test="local-name(../*[3]/*[1])='minus'">-</xsl:if><xsl:apply-templates select="../*[3]/*[3]/*[3]"/>
			</xsl:when>
			<xsl:when test="$functiontype='plus' or $functiontype='minus'">
				<xsl:call-template name="diffterms">
				<xsl:with-param name="differential" select="$differential"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="local-name(../*[3])='ci' and ../*[3]=$differential">
				<xsl:text>1.0</xsl:text>
			</xsl:when>
		<xsl:otherwise><!--This is here to show what needs implementation-->
			<xsl:apply-templates select="../*[3]">
			<xsl:with-param name="differential" select="$differential"/>
			</xsl:apply-templates>/d<xsl:value-of select="$differential"/>//<xsl:value-of select="../*[3]"/>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template match="math:partialdiff" name="partialdiff">
		<xsl:param name="differential" select="translate(../child::math:bvar, ' ','')"/>
		<xsl:variable name="functiontype" select="local-name(../*[3]/*[3]/*[1])"/>
		<xsl:choose>
			<!--The case where it is a derivative of a function defined elsewhere in the mathml document.-->
			<xsl:when test="local-name(../*[3]/*[1])='csymbol'">
			<xsl:variable name="functionDescription" select="translate(concat(../*[3]/*[1], ../*[3]/*[2]),' &#9;&#10;&#13;','')"/>

			<!--Get the function document location from the functions key table-->
				<xsl:for-each select="key('functions', $functionDescription)">
					<xsl:choose>
					<xsl:when test="local-name(../../*[1])='eq'">
						<xsl:for-each select="../../*[3]">
					<xsl:call-template name="diff">
						<xsl:with-param name="differential" select="$differential"/>
					</xsl:call-template>
						</xsl:for-each>
					</xsl:when>
					</xsl:choose>
				</xsl:for-each>
			</xsl:when>
			<!--Got an exponential function. Call diffexp...-->
			<xsl:when test="$functiontype='exp'">
				<xsl:call-template name="diffexp">
				<xsl:with-param name="differential" select="$differential"/>
				</xsl:call-template>
			</xsl:when>
			<!--Test for ax+b type of functions where a and b can be any mathml expression not including the bvar-->
			<xsl:when test="(local-name(../*[3]/*[1])='plus' or local-name(../*[3]/*[1])='minus') and local-name(../*[3]/*[2]/*[1])='times' and ../*[3]/*[2]/*[3]=$differential">
				<xsl:apply-templates select="../*[3]/*[2]/*[2]"/>
			</xsl:when>
			<xsl:when test="(local-name(../*[3]/*[1])='plus' or local-name(../*[3]/*[1])='minus')  and local-name(../*[3]/*[2]/*[1])='times' and ../*[3]/*[2]/*[2]=$differential">
				<xsl:apply-templates select="../*[3]/*[2]/*[3]"/>
			</xsl:when>
			<xsl:when test="(local-name(../*[3]/*[1])='plus' or local-name(../*[3]/*[1])='minus') and local-name(../*[3]/*[3]/*[1])='times' and ../*[3]/*[3]/*[3]=$differential">
				<xsl:if test="local-name(../*[3]/*[1])='minus'">-</xsl:if><xsl:apply-templates select="../*[3]/*[3]/*[2]"/>
			</xsl:when>
			<xsl:when test="(local-name(../*[3]/*[1])='plus' or local-name(../*[3]/*[1])='minus') and local-name(../*[3]/*[3]/*[1])='times' and ../*[3]/*[3]/*[2]=$differential">
				<xsl:if test="local-name(../*[3]/*[1])='minus'">-</xsl:if><xsl:apply-templates select="../*[3]/*[3]/*[3]"/>
			</xsl:when>
			<xsl:when test="$functiontype='plus' or $functiontype='minus'">
				<xsl:call-template name="diffterms">
				<xsl:with-param name="differential" select="$differential"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="local-name(../*[3])='ci' and ../*[3]=$differential">
				<xsl:text>1.0</xsl:text>
			</xsl:when>
		<xsl:otherwise><!--This is here to show what needs implementation-->
			<xsl:apply-templates select="../*[3]">
			<xsl:with-param name="differential" select="$differential"/>
			</xsl:apply-templates>/d<xsl:value-of select="$differential"/>//<xsl:value-of select="../*[3]"/>
		</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
